import { element, by, ElementFinder } from 'protractor';

export class StatisticsComponentsPage {
  createButton = element(by.id('jh-create-entity'));
  deleteButtons = element.all(by.css('jhi-statistics div table .btn-danger'));
  title = element.all(by.css('jhi-statistics div h2#page-heading span')).first();
  noResult = element(by.id('no-result'));
  entities = element(by.id('entities'));

  async clickOnCreateButton(): Promise<void> {
    await this.createButton.click();
  }

  async clickOnLastDeleteButton(): Promise<void> {
    await this.deleteButtons.last().click();
  }

  async countDeleteButtons(): Promise<number> {
    return this.deleteButtons.count();
  }

  async getTitle(): Promise<string> {
    return this.title.getAttribute('jhiTranslate');
  }
}

export class StatisticsUpdatePage {
  pageTitle = element(by.id('jhi-statistics-heading'));
  saveButton = element(by.id('save-entity'));
  cancelButton = element(by.id('cancel-save'));

  viewsInput = element(by.id('field_views'));
  downloadsInput = element(by.id('field_downloads'));
  exerciseIDInput = element(by.id('field_exerciseID'));

  async getPageTitle(): Promise<string> {
    return this.pageTitle.getAttribute('jhiTranslate');
  }

  async setViewsInput(views: string): Promise<void> {
    await this.viewsInput.sendKeys(views);
  }

  async getViewsInput(): Promise<string> {
    return await this.viewsInput.getAttribute('value');
  }

  async setDownloadsInput(downloads: string): Promise<void> {
    await this.downloadsInput.sendKeys(downloads);
  }

  async getDownloadsInput(): Promise<string> {
    return await this.downloadsInput.getAttribute('value');
  }

  async setExerciseIDInput(exerciseID: string): Promise<void> {
    await this.exerciseIDInput.sendKeys(exerciseID);
  }

  async getExerciseIDInput(): Promise<string> {
    return await this.exerciseIDInput.getAttribute('value');
  }

  async save(): Promise<void> {
    await this.saveButton.click();
  }

  async cancel(): Promise<void> {
    await this.cancelButton.click();
  }

  getSaveButton(): ElementFinder {
    return this.saveButton;
  }
}

export class StatisticsDeleteDialog {
  private dialogTitle = element(by.id('jhi-delete-statistics-heading'));
  private confirmButton = element(by.id('jhi-confirm-delete-statistics'));

  async getDialogTitle(): Promise<string> {
    return this.dialogTitle.getAttribute('jhiTranslate');
  }

  async clickOnConfirmButton(): Promise<void> {
    await this.confirmButton.click();
  }
}
